V2EX = way to explore
V2EX 是一个关于分享和探索的地方
现在注册
已注册用户请  登录
Distributions
Ubuntu
Fedora
CentOS
中文资源站
网易开源镜像站
lokamir
V2EX  ›  Linux

求教,为什么脚本运行是总会提示 grep 命令没有参数

  •  
  •   lokamir · 2021-05-16 08:37:34 +08:00 · 945 次点击
    这是一个创建于 451 天前的主题,其中的信息可能已经有所发展或是发生改变。
    学着写了一下 shell 脚本,用来备份数据库, 运行正常
    但是每次运行都会先提示 Usage: grep [OPTION]... PATTERN [FILE],之后才是"MySQL backup Starting!"

    脚本贴上
    #!/bin/bash
    # 数据库登录参数
    user="root"
    password="*******!"
    host="127.0.0.1"
    port="3306"
    db_name="www"
    # 备份文件存放地址
    backup_path="/root/backups/mysql"
    # 当天年月日
    date=$(date +"%Y-%m-%d")
    # 是否删除过期数据
    expire_backup_delete="OFF"
    expire_days=7
    backup_time=$date
    backup_dir=$backup_location
    welcome_msg="MySQL backup Starting!"
    # 判断 mysql 实例是否正常运行
    mysql_ps=`ps -ef |grep mysql |wc -l`
    mysql_listen=`netstat -an |grep LISTEN |grep $mysql_port|wc -l`
    if [ [$mysql_ps == 0] -o [$mysql_listen == 0] ]; then
    echo "ERROR:MySQL is not running! backup stop!"
    exit
    else
    echo $welcome_msg
    fi
    # 数据库到 SQL 文件
    mysqldump -u$user -p$password -h$host -P$port $db_name > $backup_path/$db_name-$date.sql
    flag=`echo $?`
    if [ $flag == "0" ];then
    echo "database mysql_backup_$db_name success backup to $backup_dir/$db_name-$date.sql.gz"
    else
    echo "database mysql_backup_$db_name backup fail!"
    fi
    # 备份写入日志
    echo "$backup_path/$db_name-$date" >> $backup_path/log.txt
    # 删除过期数据
    if [ "$expire_backup_delete" == "ON" -a "$backup_location" != "" ];then
    `find $backup_location/ -type f -mtime +$expire_days | xargs rm -rf`
    echo "Expired backup data delete complete!"
    fi
    iBugOne
        1
    iBugOne  
       2021-05-16 08:39:49 +08:00   ❤️ 1
    grep $mysql_port 你没定义变量
    lokamir
        2
    lokamir  
    OP
       2021-05-16 08:48:51 +08:00
    @iBugOne 吐血,我的眼睛要治治了
    lokamir
        3
    lokamir  
    OP
       2021-05-16 08:51:45 +08:00
    @iBugOne
    问一下,这句 mysql_listen=`netstat -an |grep LISTEN |grep $mysql_port|wc -l` 没有执行成功,后面判断为什么还是进行下去了
    yuanmomo
        4
    yuanmomo  
       2021-05-16 09:36:42 +08:00 via iPhone   ❤️ 4
    @lokamir 脚本前面加上
    ######## set bash configurations
    # 命令返回非 0 时,就退出
    set -o errexit
    # 管道命令中任何一个失败,就退出
    set -o pipefail
    # 遇到不存在的变量就会报错,并停止执行
    set -o nounset
    # 在执行每一个命令之前把经过变量展开之后的命令打印出来,调试时很有用
    #set -o xtrace
    iBugOne
        5
    iBugOne  
       2021-05-16 10:08:09 +08:00
    你这个脚本写得也太乱了吧

    if [ [$mysql_ps == 0] -o [$mysql_listen == 0] ];

    Shell 里所有参数都是空格分隔的,然后 == 是字符串比较(而且应该是用一个 =),所以你的判断条件就变成了

    if [ "[$mysql_ps" = "0]" -o "[$mysql_listen" = "0]" ];

    显然这两个字符串都不可能相等,所以 if 里面的错误处理就没执行

    正确的写法是

    if [ "$mysql_ps" -eq 0 -o "$mysql_listen" -eq 0 ];

    建议写完脚本用 shellcheck 或者 https://www.shellcheck.net/ 跑一下,能省很多事
    julyclyde
        6
    julyclyde  
       2021-05-17 12:31:15 +08:00
    而且“判断是否运行”也没什么意义啊
    关于   ·   帮助文档   ·   API   ·   FAQ   ·   我们的愿景   ·   广告投放   ·   感谢   ·   实用小工具   ·   1101 人在线   最高记录 5497   ·     Select Language
    创意工作者们的社区
    World is powered by solitude
    VERSION: 3.9.8.5 · 306ms · UTC 19:55 · PVG 03:55 · LAX 12:55 · JFK 15:55
    Developed with CodeLauncher
    ♥ Do have faith in what you're doing.